program f 

 implicit none 

 integer,parameter::lng_unit=11,lat_unit=12,input_unit=10,output_unit=20
 integer,parameter::config_unit=30

 integer::i,j,n

 integer::imax,jmax

 integer::jyr,jmon,jday,jhour,jsec,jmin
 integer::uyr,umon,uday,uhour,usec,umin

 integer::grdi,grdj
 integer::d_start,d_end

 integer::num_file

 integer::izzz

 real::lng,lat

 real,dimension(:,:),allocatable::a
 real,dimension(:,:),allocatable::dmax,dmin

 character(3)::t_zone
 character(4)::year
 character(14)::cdate

 character(200)::varible_name
 character(200)::config_file

 character(200)::lat_file,lng_file,latlng_dir
 character(200)::dir_input_f,input_f
 character(200)::dir_output_f,max_f,min_f

 character(200)::czzz

 max_f="maxmum.bin"
 min_f="minimum.bin"

 config_file="config/format.txt"

! varible_name="dwn.sw.flx.sfc.msm"


!***** read config file *****
 open(config_unit,FILE=config_file,STATUS='old')

 read(config_unit,*)imax,izzz
 read(config_unit,*)jmax,izzz
 read(config_unit,*)varible_name,izzz

 read(config_unit,'(a)')czzz
 dir_input_f=czzz(1:index(czzz,"/"))

 do i=1,4,1
   read(config_unit,'()')
 enddo

 read(config_unit,'(a)')czzz
 dir_output_f=czzz(1:index(czzz,"/"))

 do i=1,2,1
   read(config_unit,'()')
 enddo

 read(config_unit,'(a)')czzz
 latlng_dir=czzz(1:index(czzz,"/"))

 read(config_unit,*)lat_file,izzz
 read(config_unit,*)lng_file,izzz

 do i=1,2,1
   read(config_unit,'()')
 enddo

 read(config_unit,*)d_start,izzz
 read(config_unit,*)d_end,izzz

 close(config_unit)

 write(*,*)"YYYY"
 read(*,*)jyr

 write(*,*)"MM"
 read(*,*)jmon

 allocate(a(1:imax,1:jmax),dmax(1:imax,1:jmax),dmin(1:imax,1:jmax))

!***初期化***** 
 dmax=0.0
 dmin=1400.0
 num_file=0
!**************

 do jday=d_start,d_end,1
   do jhour=0,23,1
     do jmin=0,59,1

       write(*,*)"JST",jyr,jmon,jday,jhour,jmin,jsec

       call jst2utc(jyr,jmon,jday,jhour,jmin,jsec,uyr,umon,uday,uhour,umin,usec)

       write(*,*)"UTC",uyr,umon,uday,uhour,umin,usec

       call int2chara(uyr,umon,uday,uhour,umin,usec,cdate)

       input_f=dir_input_f(1:len_trim(dir_input_f))//cdate(1:len_trim(cdate))//&
                 varible_name(1:len_trim(varible_name))//".bin"

       open(input_unit,FILE=input_f,FORM='unformatted',STATUS='old',ACCESS ='direct',CONVERT='big_endian',&
         RECL=4*imax*jmax,err=900)

       read(input_unit,rec=1)a
       num_file=num_file+1
 
       do j=1,jmax,1
         do i=1,imax,1

 !***最大値を決める***
           if(a(i,j) .gt. dmax(i,j))then
             dmax(i,j)=a(i,j)
           endif

!***最小値を決める***
           if(a(i,j) .lt. dmin(i,j))then
             dmin(i,j)=a(i,j)
           endif

           close(input_unit)

         enddo
       enddo

900 continue

     enddo
   enddo
 enddo
 
 if(num_file .ge. 2)then

   open(output_unit,FILE=dir_output_f(1:len_trim(dir_output_f))//max_f,&
     FORM='unformatted',STATUS='unknown',ACCESS ='direct',CONVERT='big_endian',&
     RECL=4*imax*jmax)

   write(output_unit,rec=1)dmax
   close(output_unit)

   open(output_unit,FILE=dir_output_f(1:len_trim(dir_output_f))//min_f,&
     FORM='unformatted',STATUS='unknown',ACCESS ='direct',CONVERT='big_endian',&
     RECL=4*imax*jmax)

   write(output_unit,rec=1)dmin
   close(output_unit)

 else

   write(*,*)""
   stop

 endif

 deallocate(a,dmax,dmin)

end program f


Subroutine searchgrid_dis(imax,jmax,lat_unit,lng_unit,lat,lng,grdi,grdj,grdlng,grdlat)

 implicit none

 integer,intent(in)::imax,jmax
 integer,intent(in)::lat_unit,lng_unit
 real,intent(in)::lat,lng

 integer,intent(out)::grdi,grdj
 real,intent(out)::grdlng,grdlat

 real,parameter::radius=6.37,pai=3.141592

 integer::i,j

 real::angle,min_angle
 real::amp_v1,amp_v2,innerpro
 real,dimension(3)::v1,v2
 real,dimension(imax,jmax)::a,b

 grdi=1
 grdj=1

 v1(1)=cos(pai*lat/180.0)*cos(2.0*pai*lng/360.0)
 v1(2)=cos(pai*lat/180.0)*sin(2.0*pai*lng/360.0)
 v1(3)=sin(pai*lat/180.0)

 amp_v1=sqrt(v1(1)**2+v1(2)**2+v1(3)**2)

 read(lng_unit,rec=1)a
 read(lat_unit,rec=1)b

 min_angle=pai

 do j=1,jmax,1
   do i=1,imax,1

     v2(1)=cos(pai*b(i,j)/180.0)*cos(2.0*pai*a(i,j)/360.0)
     v2(2)=cos(pai*b(i,j)/180.0)*sin(2.0*pai*a(i,j)/360.0)
     v2(3)=sin(pai*b(i,j)/180.0)

     amp_v2=sqrt(v2(1)**2+v2(2)**2+v2(3)**2)
     innerpro=v1(1)*v2(1)+v1(2)*v2(2)+v1(3)*v2(3)

     angle=acos(innerpro/amp_v1/amp_v2)

     if(abs(angle) .lt. abs(min_angle))then

       min_angle=angle
       grdi=i
       grdj=j

     endif

   enddo
 enddo

 grdlng=a(grdi,grdj)
 grdlat=b(grdi,grdj)

End Subroutine searchgrid_dis



subroutine jst2utc(jyr,jmon,jday,jhour,jsec,jmin,uyr,umon,uday,uhour,usec,umin)

 implicit none

 integer,parameter::tzone=-9

 integer::jyr,jmon,jday,jhour,jsec,jmin
 integer::uyr,umon,uday,uhour,usec,umin

 integer::leap_chk

 integer,dimension(12)::num_date

 data num_date/31,28,31,30,31,30,31,31,30,31,30,31/

 usec=jsec
 umin=jmin

 call check_leapyear(jyr,leap_chk)

 if(jhour .ge. 9)then

   uhour=jhour+tzone
   uday=jday
   umon=jmon
   uyr=jyr

 else

   uhour=jhour+24+tzone

   if(jday .ne. 1)then

     uday=jday-1
     umon=jmon
     uyr=jyr
 
   else

     if(jmon .ne. 1 .and. jmon .ne. 3)then

       umon=jmon-1
       uday=num_date(umon)
       uyr=jyr

     elseif(jmon .eq. 1)then

       umon=jmon-1+12
       uday=num_date(umon)
       uyr=jyr

     elseif(jmon .eq. 3)then

       if(leap_chk .ne. 1)then 

         umon=jmon-1
         uday=num_date(umon)
         uyr=jyr

       else

         umon=jmon-1
         uday=num_date(umon)+1
         uyr=jyr

       endif
     endif
   endif
 endif

end subroutine jst2utc


subroutine check_leapyear(yr,leap_chk)

 implicit none

 integer,intent(in)::yr
 integer,intent(out)::leap_chk

 if(mod(yr,400) .eq. 0) then
   leap_chk=1
 else if((mod(yr,4) .eq. 0).and.(mod(yr,100) .gt. 0)) then
   leap_chk=1
 else
   leap_chk=0
 endif

end subroutine check_leapyear 



subroutine int2chara(uyr,umon,uday,uhour,usec,umin,cdate)

 implicit none

 integer,intent(in)::uyr,umon,uday,uhour,usec,umin

 character(14),intent(out)::cdate

 character(2)::cmon,cday,chour,csec,cmin
 character(4)::cyr

 write(cyr,'(i4)')uyr

 if (umon .ge. 10)then
   write(cmon,'(i2)')umon
 else
   cmon(1:1)="0"
   write(cmon(2:2),'(i1)')umon
 endif

 if (uday .ge. 10)then
   write(cday,'(i2)')uday
 else
   cday(1:1)="0"
   write(cday(2:2),'(i1)')uday
 endif

 if (uhour .ge. 10)then
   write(chour,'(i2)')uhour
 else
   chour(1:1)="0"
   write(chour(2:2),'(i1)')uhour
 endif

 if (usec .ge. 10)then
   write(csec,'(i2)')usec
 else
   csec(1:1)="0"
   write(csec(2:2),'(i1)')usec
 endif


 if (umin .ge. 10)then
   write(cmin,'(i2)')umin
 else
   cmin(1:1)="0"
   write(cmin(2:2),'(i1)')umin
 endif

 cdate=cyr(1:len_trim(cyr))//cmon(1:len_trim(cmon))//cday(1:len_trim(cday))//&
           chour(1:len_trim(chour))//csec(1:len_trim(csec))

end subroutine



